--- gdb-6.4.old/gdb/p-lang.c	2005-10-03 17:21:20.000000000 -0400
+++ gdb-6.4/gdb/p-lang.c	2006-04-03 13:27:40.000000000 -0400
@@ -48,8 +48,9 @@
    but this does not happen for Free Pascal nor for GPC.  */
 int
 is_pascal_string_type (struct type *type,int *length_pos,
-                       int *length_size, int *string_pos, int *char_size,
-		       char **arrayname)
+                       int *length_size, int *capacity_pos,
+                       int *capacity_size,int *string_pos,
+                       int *char_size, char **arrayname)
 {
   if (TYPE_CODE (type) == TYPE_CODE_STRUCT)
     {
@@ -61,8 +62,12 @@
         {
           if (length_pos)
 	    *length_pos = TYPE_FIELD_BITPOS (type, 0) / TARGET_CHAR_BIT;
+          if (capacity_pos)
+      *capacity_pos = *length_pos;  /* Fake capacity */
           if (length_size)
 	    *length_size = TYPE_LENGTH (TYPE_FIELD_TYPE (type, 0));
+          if (capacity_size)
+      *capacity_size = *length_size;  /* Fake capacity */
           if (string_pos)
 	    *string_pos = TYPE_FIELD_BITPOS (type, 1) / TARGET_CHAR_BIT;
           if (char_size)
@@ -77,6 +82,10 @@
           && strcmp (TYPE_FIELDS (type)[0].name, "Capacity") == 0
           && strcmp (TYPE_FIELDS (type)[1].name, "length") == 0)
         {
+          if (capacity_pos)
+      *capacity_pos = TYPE_FIELD_BITPOS (type, 0) / TARGET_CHAR_BIT;
+          if (capacity_size)
+      *capacity_size = TYPE_LENGTH (TYPE_FIELD_TYPE (type, 0));
           if (length_pos)
 	    *length_pos = TYPE_FIELD_BITPOS (type, 1) / TARGET_CHAR_BIT;
           if (length_size)
